

format   PE native ;at 0x100000
entry    DriverEntry
include  'win32ax.inc'
include  'equates\wdm32.inc'

;//****** STRING *************
section '.data' data readable writeable notpageable

DevName    du  '\Device\Codeby',0
linkName   du  '\??\Codeby',0

pDevName   UNICODE_STRING
plinkName  UNICODE_STRING

pDevObj    dd  0
Status     dd  0

;//****** MAIN ***************
section '.text' code readable executable notpageable

proc  DriverEntry, pDrvObject, pRegPath

;//    
       invoke  RtlInitUnicodeString,pDevName,DevName
       invoke  RtlInitUnicodeString,plinkName,linkName
      cinvoke  DbgPrint,<'Init string   OK!',0>

;// C . -
       invoke  IoCreateDevice,[pDrvObject],0,pDevName,\
                              FILE_DEVICE_UNKNOWN,\
                              FILE_DEVICE_SECURE_OPEN,0,pDevObj
       or      eax,eax
       je      @f
       mov     [Status],eax
      cinvoke  DbgPrint,<'CreateDevice error:  %08x',0>,eax
       jmp     @exit
@@:   cinvoke  DbgPrint,<'CreateDevice  OK!  %08x',0>,[pDevObj]

;// C   -   
       invoke  IoCreateSymbolicLink,plinkName,pDevName
       or      eax,eax
       je      @f
       mov    [Status],eax
      cinvoke  DbgPrint,<'Create link ERROR! %08x',0>,eax
       jmp     @exit
@@:   cinvoke  DbgPrint,<'Create link   OK!',10,'--------',0>

;//   
       mov     esi,[pDrvObject]
       mov    [esi + DRIVER_OBJECT.DriverUnload] ,CodebyUnload
       mov    [esi + DRIVER_OBJECT.IRP_MJ_CREATE],CodebyCreate
       mov    [esi + DRIVER_OBJECT.IRP_MJ_CLOSE] ,CodebyClose
       mov    [esi + DRIVER_OBJECT.IRP_MJ_DEVICE_CONTROL],CodebyControl

;//   -   Ok
       mov    [Status],STATUS_SUCCESS
@exit: mov    eax,[Status]
       ret
endp

;//********************************************************
;//   -   Dispatch
;//********************************************************
align  16
proc   CodebyUnload, pDrvObject
       invoke  IoDeleteSymbolicLink,plinkName
       invoke  IoDeleteDevice,[pDevObj]
      cinvoke  DbgPrint,<'Unload driver OK!',0>
       mov     eax,STATUS_SUCCESS  ; STATUS_DEVICE_CONFIGURATION_ERROR
       ret
endp
;//----------------
align  16
proc   CodebyCreate,  pDevObj, pIrp
      cinvoke  DbgPrint,<'Dispatch Create! IRP: %08x',10,' ',0>,[pIrp]
       invoke  IoCompleteRequest,[pIrp],IO_NO_INCREMENT
       mov     eax,STATUS_SUCCESS
       ret
endp
;//----------------
align  16
proc   CodebyClose,   pDevObj, pIrp
      cinvoke  DbgPrint,<'Dispatch Close!  IRP: %08x',10,'--------',0>,[pIrp]
       invoke  IoCompleteRequest,[pIrp],IO_NO_INCREMENT
       mov     eax,STATUS_SUCCESS
       ret
endp
;//----------------
align  16
proc   CodebyControl, pDevObj, pIrp  ; 0x220004
       mov     esi,[pIrp]
       mov     esi,[esi + _IRP.CurrentStackLocation]
       lea     esi,[esi + IO_STACK_LOCATION.Parameters]
       mov     eax,[esi + PARAM_IO_CONTROL.IoControlCode]

       mov     ebx,[fs:KPCR.Irql]

      cinvoke  DbgPrint,<'Dispatch IoControl',10,\
                         'IOCTL: %08x  IRP: %08x  IRQL: %d',10,' ',0>,eax,[pIrp],ebx

       invoke  IoCompleteRequest,[pIrp],IO_NO_INCREMENT
       mov     eax,STATUS_SUCCESS
       ret
endp

;//**************************
section '.idata' import data readable writeable
library  ntoskrnl,"ntoskrnl.exe"
include 'api\ntoskrnl.inc'
;//**************************
section '.reloc' data fixups readable discardable

